routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Auth::routes(['register' => false]);

Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::prefix('score')->name('score.')->middleware('auth')->group(function(){
    Route::get('/', [App\Http\Controllers\ScoreController::class, 'list'])->name('list');
    Route::get('/create', [App\Http\Controllers\ScoreController::class, 'create'])->name('create');
    Route::post('/create', [App\Http\Controllers\ScoreController::class, 'store'])->name('store');
    Route::get('/detail/{nim}', [App\Http\Controllers\ScoreController::class, 'detail'])->name('detail');
    Route::delete('/delete/{nim}', [App\Http\Controllers\ScoreController::class, 'delete'])->name('delete');
    Route::get('/edit/{nim}', [App\Http\Controllers\ScoreController::class, 'edit'])->name('edit');
    Route::put('/edit/{nim}', [App\Http\Controllers\ScoreController::class, 'update'])->name('update');
});

app/Http/Controllers/ScoreController.php
<?php

namespace App\Http\Controllers;

use App\Models\Student;
use App\Models\StudentScore;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;

class ScoreController extends Controller
{
    public function create()
    {
        return view('scores.create');
    }

    public function list(Request $request)
    {
        $students = Student::with('score')->simplePaginate(10);

        return view('scores.list', [
            'students' => $students
        ]);
    }

    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            "name" => ["required"],
            "nim" => ["required"],
            "score_quiz" => ["required", "gte:0", "lte:100"],
            "score_task" => ["required", "gte:0", "lte:100"],
            "score_attendance" => ["required", "gte:0", "lte:100"],
            "score_practice" => ["required", "gte:0", "lte:100"],
            "score_final_exams" => ["required", "gte:0", "lte:100"],
        ],[
            "required" => ":attribute is required",
            "gte" => "Please fill out score between 0 - 100",
            "lte" => "Please fill out score between 0 - 100",
        ]);

        if ($validator->fails()) {
            return redirect()->back()->withInput()->withErrors($validator);
        }

        DB::beginTransaction();
        try {
            $checkStudent = Student::where(['nim' => $request->nim])->first();
            if ($checkStudent) {
                return redirect()->back()->withInput()->with('error', "Duplicate Entry - [".$request->name." - ".$request->nim."] score already submitted. <a href='".route('score.detail', $checkStudent->nim)."'>Click here to edit score</a>");
            }

            $student = Student::updateOrCreate([
                'nim' => $request->nim
            ],
            [
                'name' => $request->name
            ]);
            
            $averageScore = collect([
                $request->score_quiz,
                $request->score_task,
                $request->score_attendance,
                $request->score_practice,
                $request->score_final_exams,
            ])->average();

            $studentScores = StudentScore::updateOrCreate([
                'student_id' => $student->id
            ],
            [
                'score_quiz' => $request->score_quiz,
                'score_task' => $request->score_task,
                'score_attendance' => $request->score_attendance,
                'score_practice' => $request->score_practice,
                'score_final_exams' => $request->score_final_exams,
                'score_average' => $averageScore
            ]);

            DB::commit();

            return redirect()->back()->with('success', "Score [".$request->name." - ".$request->nim."] submitted successfully");
        } catch (\Throwable $th) {
            DB::rollBack();
            
            return redirect()->back()->withInput()->with('error', $th->getMessage());
        }        
    }

    public function delete(Request $request)
    {
        $student = Student::where('nim', $request->nim)->first();
        StudentScore::where('student_id', $student->id)->delete();
        $student->delete();
        
        return redirect()->back()->with('success', "Score [".$student->name." - ".$student->nim."] deleted successfully");
    }

    public function edit(Request $request)
    {
        $student = Student::with('score')->where('nim', $request->nim)->first();

        return view('scores.edit', [
            'student' => $student
        ]);
    }

    public function update(Request $request)
    {
        $validator = Validator::make($request->all(), [
            "name" => ["required"],
            "nim" => ["required"],
            "score_quiz" => ["required", "gte:0", "lte:100"],
            "score_task" => ["required", "gte:0", "lte:100"],
            "score_attendance" => ["required", "gte:0", "lte:100"],
            "score_practice" => ["required", "gte:0", "lte:100"],
            "score_final_exams" => ["required", "gte:0", "lte:100"],
        ],[
            "required" => ":attribute is required",
            "gte" => "Please fill out score between 0 - 100",
            "lte" => "Please fill out score between 0 - 100",
        ]);

        if ($validator->fails()) {
            return redirect()->back()->withInput()->withErrors($validator);
        }

        DB::beginTransaction();
        try {
            $student = Student::updateOrCreate([
                'nim' => $request->nim
            ],
            [
                'name' => $request->name
            ]);
            
            $averageScore = collect([
                $request->score_quiz,
                $request->score_task,
                $request->score_attendance,
                $request->score_practice,
                $request->score_final_exams,
            ])->average();

            $studentScores = StudentScore::updateOrCreate([
                'student_id' => $student->id
            ],
            [
                'score_quiz' => $request->score_quiz,
                'score_task' => $request->score_task,
                'score_attendance' => $request->score_attendance,
                'score_practice' => $request->score_practice,
                'score_final_exams' => $request->score_final_exams,
                'score_average' => $averageScore
            ]);

            DB::commit();

            return redirect()->back()->with('success', "Score [".$request->name." - ".$request->nim."] updated successfully");
        } catch (\Throwable $th) {
            DB::rollBack();
            
            return redirect()->back()->withInput()->with('error', $th->getMessage());
        }    
    }
}

resources/views/scores/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Submit Student Score') }}</div>

                <div class="card-body">
                    @if(session('success'))
                        <div class="alert alert-success">{!! session('success') !!}</div>
                    @endif

                    @if(session('error'))
                        <div class="alert alert-danger">{!! session('error') !!}</div>
                    @endif

                    <form method="POST" action="{{ route('score.store') }}">
                        @csrf

                        <div class="row mb-3">
                            <label for="name" class="col-md-4 col-form-label text-md-end">{{ __('Name') }}</label>

                            <div class="col-md-6">
                                <input id="name" type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ old('name') }}" required autocomplete="name" autofocus>

                                @error('name')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="nim" class="col-md-4 col-form-label text-md-end">{{ __('NIM') }}</label>

                            <div class="col-md-6">
                                <input id="nim" type="number" class="form-control @error('nim') is-invalid @enderror" name="nim" value="{{ old('nim') }}" required autocomplete="nim">

                                @error('email')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row">
                            <hr>
                        </div>

                        <div class="row mb-3">
                            <label for="score_quiz" class="col-md-4 col-form-label text-md-end">{{ __('Nilai Quiz') }}</label>

                            <div class="col-md-6">
                                <input id="score_quiz" type="number" max="100" class="form-control @error('score_quiz') is-invalid @enderror" name="score_quiz" value="{{ old('score_quiz') }}" required autocomplete="score_quiz">

                                @error('score_quiz')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="score_task" class="col-md-4 col-form-label text-md-end">{{ __('Nilai Tugas') }}</label>

                            <div class="col-md-6">
                                <input id="score_task" type="number" max="100" class="form-control @error('score_task') is-invalid @enderror" name="score_task" value="{{ old('score_task') }}" required autocomplete="score_task">

                                @error('score_task')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="score_attendance" class="col-md-4 col-form-label text-md-end">{{ __('Nilai Absensi') }}</label>

                            <div class="col-md-6">
                                <input id="score_attendance" type="number" max="100" class="form-control @error('score_attendance') is-invalid @enderror" name="score_attendance" value="{{ old('score_attendance') }}" required autocomplete="score_attendance">

                                @error('score_attendance')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="score_practice" class="col-md-4 col-form-label text-md-end">{{ __('Nilai Praktek') }}</label>

                            <div class="col-md-6">
                                <input id="score_practice" type="number" max="100" class="form-control @error('score_practice') is-invalid @enderror" name="score_practice" value="{{ old('score_practice') }}" required autocomplete="score_practice">

                                @error('score_practice')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="score_final_exams" class="col-md-4 col-form-label text-md-end">{{ __('Nilai UAS') }}</label>

                            <div class="col-md-6">
                                <input id="score_final_exams" type="number" max="100" class="form-control @error('score_final_exams') is-invalid @enderror" name="score_final_exams" value="{{ old('score_final_exams') }}" required autocomplete="score_final_exams">

                                @error('score_final_exams')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-0">
                            <div class="col-md-6 offset-md-4">
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Submit') }}
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/scores/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Edit Student Score') }}</div>

                <div class="card-body">
                    @if(session('success'))
                        <div class="alert alert-success">{!! session('success') !!}</div>
                    @endif

                    @if(session('error'))
                        <div class="alert alert-danger">{!! session('error') !!}</div>
                    @endif

                    <form method="POST" action="{{ route('score.update', $student->nim) }}">
                        @csrf
                        @method('PUT')

                        <div class="row mb-3">
                            <label for="name" class="col-md-4 col-form-label text-md-end">{{ __('Name') }}</label>

                            <div class="col-md-6">
                                <input id="name" type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ old('name') ?? $student->name }}" required autocomplete="name" autofocus>

                                @error('name')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="nim" class="col-md-4 col-form-label text-md-end">{{ __('NIM') }}</label>

                            <div class="col-md-6">
                                <input id="nim" type="number" class="form-control @error('nim') is-invalid @enderror" name="nim" value="{{ old('nim') ?? $student->nim }}" required autocomplete="nim">

                                @error('email')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row">
                            <hr>
                        </div>

                        <div class="row mb-3">
                            <label for="score_quiz" class="col-md-4 col-form-label text-md-end">{{ __('Nilai Quiz') }}</label>

                            <div class="col-md-6">
                                <input id="score_quiz" type="number" max="100" class="form-control @error('score_quiz') is-invalid @enderror" name="score_quiz" value="{{ old('score_quiz') ?? $student->score->score_quiz }}" required autocomplete="score_quiz">

                                @error('score_quiz')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="score_task" class="col-md-4 col-form-label text-md-end">{{ __('Nilai Tugas') }}</label>

                            <div class="col-md-6">
                                <input id="score_task" type="number" max="100" class="form-control @error('score_task') is-invalid @enderror" name="score_task" value="{{ old('score_task') ?? $student->score->score_task }}" required autocomplete="score_task">

                                @error('score_task')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="score_attendance" class="col-md-4 col-form-label text-md-end">{{ __('Nilai Absensi') }}</label>

                            <div class="col-md-6">
                                <input id="score_attendance" type="number" max="100" class="form-control @error('score_attendance') is-invalid @enderror" name="score_attendance" value="{{ old('score_attendance') ?? $student->score->score_attendance }}" required autocomplete="score_attendance">

                                @error('score_attendance')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="score_practice" class="col-md-4 col-form-label text-md-end">{{ __('Nilai Praktek') }}</label>

                            <div class="col-md-6">
                                <input id="score_practice" type="number" max="100" class="form-control @error('score_practice') is-invalid @enderror" name="score_practice" value="{{ old('score_practice') ?? $student->score->score_practice }}" required autocomplete="score_practice">

                                @error('score_practice')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-3">
                            <label for="score_final_exams" class="col-md-4 col-form-label text-md-end">{{ __('Nilai UAS') }}</label>

                            <div class="col-md-6">
                                <input id="score_final_exams" type="number" max="100" class="form-control @error('score_final_exams') is-invalid @enderror" name="score_final_exams" value="{{ old('score_final_exams') ?? $student->score->score_final_exams }}" required autocomplete="score_final_exams">

                                @error('score_final_exams')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="row mb-0">
                            <div class="col-md-6 offset-md-4">
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Update') }}
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/scores/list.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('List Student Score') }}</div>

                <div class="card-body">
                    @if(session('success'))
                        <div class="alert alert-success">{!! session('success') !!}</div>
                    @endif

                    @if(session('error'))
                        <div class="alert alert-danger">{!! session('error') !!}</div>
                    @endif

                    <table class="table table-striped table-hover">
                        <thead>
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">NIM</th>
                                <th scope="col">Nama</th>
                                <th scope="col">Rerata Nilai</th>
                                <th class="text-center" scope="col">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($students as $key => $student)
                            <tr>
                                <th scope="row">{!! $students->firstItem() + $key !!}</th>
                                <td>{{ $student->nim }}</td>
                                <td>{{ $student->name }}</td>
                                <td>{{ $student->score->score_average ?? 0 }}</td>
                                <td class="text-center">
                                    
                                    <form action="{{ route('score.delete',$student->nim) }}" method="POST" >
                                        @csrf
                                        @method('DELETE')
                                        <a class="ms-2 btn btn-sm btn-warning" href="{{ route('score.edit', $student->nim) }}">Edit</a>
                                        <button type="submit" class="btn btn-sm btn-danger" onclick="return confirm('Are you sure want to delete this record?')" href="{{ route('score.delete', $student->nim) }}">Delete</button>
                                    </form>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>

                    {{ $students->links() }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection